'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
// TODO export fresh-id-crypto to a separate package

// let useMathRandomBasedImplementation;

// if (typeof crypto === 'undefined') {
//   try {
//     require('crypto');
//     useMathRandomBasedImplementation = false;
//   } catch (e) {
//     useMathRandomBasedImplementation = true;
//   }
// } else {
//   useMathRandomBasedImplementation = false;
// }

var ALPHANUM = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789';
var idGenerator = void 0;

// if (useMathRandomBasedImplementation) {
idGenerator = function idGenerator() {
  var length = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 15;

  var id = '';

  for (var i = 0; i < length; i++) {
    id += ALPHANUM.charAt(Math.floor(Math.random() * ALPHANUM.length));
  }

  return id;
};
// } else {
//   const { randomBytes } = require('crypto');

//   idGenerator = (length) => {
//     let id = '';

//     const random = randomBytes(length);

//     let cursor = 0;
//     for (let i = 0; i < length; i += 1) {
//       cursor += random[i];
//       id += ALPHANUM[cursor % ALPHANUM.length];
//     }

//     return id;
//   };
// }

exports.default = function () {
  var length = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 15;

  if (length < 1) {
    throw new Error('Ids must be at least one character long');
  }

  return idGenerator(length);
};